function [xB,P]=rq_purify_final(xB,Ih,Ihc,P,K,Xny,yny)
%
% Call:
%
%     [xB,P]=rq_purify_final(xB,Ih,Ihc,P,K,Xny,yny)
%
% This function takes care of infeasible points in a simplex formulation 
% of a quantile regression problem. The underlying assumption in this
% function is that there are no restrictions in the in the problem. 
%
% The updating can therefore be done by recalculatin all residuals and
% coefficients.
% 
% The assumptions is further that we are in a position s.t.
%
%  Xny*Xny(Ih)^(-1)*yny(Ih)=yny+residuals
%
% K=rank(Xny)
% Input as in rq_simplex_final
invXh=Xny(Ih,1:end)^-1;
xB=[invXh*yny(Ih);yny(Ihc)-Xny(Ihc,1:end)*invXh*yny(Ih)];
P=sign(xB(K+1:end));
P(P==0)=ones(sum(P==0),1);
xB(K+1:end)=abs(xB(K+1:end));